QGIS Application - Bug report #13977
QgsVectorFileWriter: bug at saving vector layer to shapefile
2015-12-11 01:49 AM - Hannes Kohlmann

Status: Closed

Priority: Normal

Assignee:

Category: PyQGIS Console

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution: invalid
Crashes QGIS or corrupls data: Copied to github as #: 21991
Description

When trying to save a layer, | get error number 3 in the case of the following example:
QgsVectorFileWriter.writeAsVectorFormat(layer, "C:\\Users\\Myname\\Desktop\\test1\\test2\\vectorlayer.shp", "utf-8", None, "ESRI
Shapefile") would NOT work, while

QgsVectorFileWriter.writeAsVectorFormat(layer, "C:\\Users\\Myname\\desktop\\Test1\\Test2\\vectorlayer.shp", "utf-8", None, "ESRI
Shapefile") does work (focus on the upper/lower case of the filepath)!

There seems to be case sensitivity after my folder "desktop"..lower case of "desktop" itself does not matter but if any of the folders after
desktop is lower case, | get without exception the error number 3 from QgsVectorFileWriter::WriterError

History

#1 - 2015-12-11 01:53 AM - Hannes Kohimann

Platform used while detecting this bug was Windows 7. | don't know know about Linux, where case sensitivity of paths is native!

#2 - 2015-12-26 09:11 PM - Simon Chenery

Use one of the following filenames to avoid Python escape sequence conversion of \\t to TAB in your filename:

"C:\\WUsers\\W\Myname\\\\Desktop\\\test1\\\\test2\\\\vectorlayer.shp"
"C:/Users/Myname/Desktop/test1/test2/vectorlayer.shp”

Does that fix your problem?

#3 - 2015-12-27 03:56 AM - Giovanni Manghi

- Target version deleted (Future Release - High Priority)

- Status changed from Open to Feedback

#4 - 2015-12-29 07:37 PM - Sebastian Dietrich

Simon Chenery wrote:

Use one of the following filenames to avoid Python escape sequence conversion of \\t to TAB in your filename:

"C:\WUsers\\\\Myname\\\\Desktop\\\\test 1\\\\test2\\\\vectorlayer.shp”
"C:/Users/Myname/Desktop/test1/test2/vectorlayer.shp”
Does that fix your problem?

| could reproduce using the OP's setup. And for me, using either one of your solutions fixes it.

Too bad Microsoft chose the wrong slash as their directory separator :-(

>>> QgsVectorFileWriter.writeAsVectorFormat(layer, "C:\\Users\\Myname\\Desktop\\test\\vectorlayer.shp", "utf-8", None, "ESRI Shapefile")

3
>>> QgsVectorFileWriter.writeAsVectorFormat(layer, "C:\\Users\\Myname\\Desktop\\Test\\Vectorlayer.shp", "utf-8", None, "ESRI Shapefile")

0
QgsVectorFileWriter.writeAsVectorFormat(layer, "C:\\Users\\Myname\\Desktop\\\\test\\Vectorlayer.shp", "utf-8", None, "ESRI Shapefile")
0

QgsVectorFileWriter.writeAsVectorFormat(layer, "C:\\Users\\Myname\\Desktop/test\\Vectorlayer.shp", "utf-8", None, "ESRI Shapefile")
0

And yes, one should escape every \\, not just the one causing problems. | plead guilty of laziness :-)

#5 - 2015-12-30 12:09 AM - Nyall Dawson

- Status changed from Feedback to Closed
- Resolution set to invalid

As explained, not a bug in QGIS
